﻿if KarmaStub:isLib("KarmaAce", 1.0, "$Revision: 99999 $") then return end


--[[
	Simple lightweight support for other libraries and systems
]]

KarmaAce = {

}

function KarmaAce:OnVariablesLoadedAce( frame, inst )

	self._locale = self._locale or {
		mt = {	__newindex = function( t, k, v ) if t[1] then t[1][k] = v end; end,
				__index = function( t, k ) if not k then return end; if rawget(t,k) then return rawget(t,k) end;
					local _,_,c,s,r,f,v = string.find(k, "^(|c%x%x%x%x%x%x%x%x)(.-)(|r)$");
					if c then k,s = s,k end
					for i, v in pairs(t) do
						if type(v) == "table" then
							v = v[k]; f = f or v;
							if v and (i==1 or v~=k) then 
								return c and (c..v..r) or v
							end;
						end
					end;
					if not f then t[k] = k end;
					return c and s or (f or k);
				end,
		},
		proxy	= {	__newindex = function( t, k, v ) end, __index = function( t, k ) return rawget(rawget(t,1),k); end,	},
		proxyr	= { __newindex = function( t, k, v ) end, __index = function( t, k ) for i, v in pairs(rawget(t,1)) do if v==k then return i end end end, },
		format  = function(t, s, ...) return s and string.format(t[s], ...); end,
	};
	
	inst._acelib = {
		name	= inst._instance.name.."Ace",
		nameDB	= inst._instance.name.."AceDB",
		lib = {
			L	= LibStub and LibStub("AceLocale-3.0", true),
			LZ	= LibStub and LibStub("LibBabble-Zone-3.0", true),
			LB	= LibStub and LibStub("LibBabble-Boss-3.0", true),
			LC	= LibStub and LibStub("LibBabble-Class-3.0", true),
			LI	= LibStub and LibStub("LibBabble-Inventory-3.0", true),
			LT	= LibStub and LibStub("LibBabble-CreatureType-3.0", true),
			fu	= LibStub and LibStub("LibFuBarPlugin-3.0", true);
			aao	= LibStub and LibStub("AceAddon-3.0", true);
			db	= LibStub and LibStub("AceDB-3.0", true);
		},
		defaults = {
			profile = { minimap = { show = true, position = 225, }, },
			global = { LCapture = { [inst._meta.locale]={} }, LCaptureR = { [inst._meta.locale]={} }, },
		};
		locale = { }, L = nil, LR = nil,		
	};
	local _inst = inst._acelib;
		
	_inst.db				= _inst.lib.db	and _inst.lib.db:New(_inst.nameDB, _inst.defaults) or inst:_GetDB(nil, _inst.nameDB, _inst.defaults, true);
	_inst.locale.capture	= inst._meta.lcapture and _inst.db.global.LCapture[inst._meta.locale] or { }
	_inst.locale.base		= _inst.lib.L	and setmetatable({_inst.lib.L:GetLocale(inst._instance.name, true) or {}},self._locale.proxy);
	_inst.locale.zone		= _inst.lib.LZ	and inst:SafeCall(_inst.lib.LZ.GetUnstrictLookupTable, _inst.lib.LZ);
	_inst.locale.boss		= _inst.lib.LB	and inst:SafeCall(_inst.lib.LB.GetUnstrictLookupTable, _inst.lib.LB);
	_inst.locale.class		= _inst.lib.LC	and inst:SafeCall(_inst.lib.LC.GetUnstrictLookupTable, _inst.lib.LC);
	_inst.locale.inv		= _inst.lib.LI	and inst:SafeCall(_inst.lib.LI.GetUnstrictLookupTable, _inst.lib.LI);
	_inst.locale.ctype		= _inst.lib.LT	and inst:SafeCall(_inst.lib.LT.GetUnstrictLookupTable, _inst.lib.LT);
	_inst.locale.captureR	= inst._meta.lcapture and _inst.db.global.LCaptureR[inst._meta.locale] or { }
	_inst.locale.baseR		= _inst.lib.L	and setmetatable({_inst.lib.L:GetLocale(inst._instance.name, true) or {}},self._locale.proxyr);
	_inst.locale.zoneR		= _inst.lib.LZ	and inst:SafeCall(_inst.lib.LZ.GetReverseLookupTable, _inst.lib.LZ);
	_inst.locale.bossR		= _inst.lib.LB	and inst:SafeCall(_inst.lib.LB.GetReverseLookupTable, _inst.lib.LB);
	_inst.locale.classR		= _inst.lib.LC	and inst:SafeCall(_inst.lib.LC.GetReverseLookupTable, _inst.lib.LC);
	_inst.locale.invR		= _inst.lib.LI	and inst:SafeCall(_inst.lib.LI.GetReverseLookupTable, _inst.lib.LI);
	_inst.locale.ctypeR		= _inst.lib.LT	and inst:SafeCall(_inst.lib.LT.GetReverseLookupTable, _inst.lib.LT);
	local _L,_LG = _inst.locale,self._locale;
	_inst.L = setmetatable({_L.capture, _L.zone, _L.boss, _L.class, _L.inv, _L.ctype, _L.base, F=_LG.format,}, _LG.mt);
	_inst.LR = setmetatable({_L.captureR, _L.zoneR, _L.bossR, _L.classR, _L.invR, _L.ctypeR, _L.baseR, F=_LG.format,}, _LG.mt);

	if KarmaLocale and KarmaLocale.OnVariablesLoaded and _inst.lib.L then
		KarmaLocale:OnVariablesLoaded( frame, inst, _inst.lib.L, inst._instance.name );
	end
end

function KarmaAce:OnPlayerLoginAce( frame, inst )
	local _inst = inst._acelib;

	_inst.instance	= _inst.lib.aao and _inst.lib.aao:NewAddon(_inst.name, "AceConsole-3.0") or { };
	_inst.menu	= _inst.L and _inst.instance and
	{ 
		handler = _inst.instance, 
		type = "group",
		name = inst._meta.title,
		desc = inst._meta.title,
		args = {
			help	= {	type = "execute", order = 10, name = _inst.L["Help"], desc = _inst.L["Show Help"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("help") end,		},
			main	= {	type = "execute", order = 10, name = _inst.L["Main Window"], desc = _inst.L["Show Main Window"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce() end,			},
			options	= {	type = "execute", order = 10, name = _inst.L["Options"], desc = _inst.L["Show Options"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("options") end,	},
		 },
	};

	if _inst.instance then													-- ace
		_inst.instance._karma				= inst;
		_inst.instance._L					= _inst.L;
		_inst.instance.db					= _inst.db;
		_inst.instance.title				= inst._meta.title;
		_inst.instance.version				= inst._meta.version;
		_inst.instance.ExecChatCommandAce	= KarmaAce.ExecChatCommandAce;
		_inst.instance.OnMenuRequest		= _inst.menu;
		_inst.instance.OnInitialize			= KarmaAce.OnInitialize;
		_inst.instance.OnUpdateFuBarTooltip	= KarmaAce.OnUpdateFuBarTooltip;
		_inst.instance.OnFuBarClick			= KarmaAce.OnFuBarClick
	end
	if _inst.lib.fu and _inst.lib.aao then									-- fubar via ace
		_inst.lib.aao:EmbedLibrary(_inst.instance, "LibFuBarPlugin-3.0", true); 
		_inst.instance:SetFuBarOption("hasIcon", true)
		_inst.instance:SetFuBarOption("iconPath", inst._meta.icon);
		_inst.instance:SetFuBarOption("hasNoColor", true)
		_inst.instance:SetFuBarOption("hideMenuTitle", true);
		_inst.instance:SetFuBarOption("independentProfile", true)
		_inst.instance:SetFuBarOption("clickableTooltip", true)
		_inst.instance:SetFuBarOption("cannotDetachTooltip", true)
		_inst.instance:SetFuBarOption("hideWithoutStandby", true)
		_inst.instance:SetFuBarOption("defaultPosition", "CENTER")
		_inst.instance:SetFuBarOption("configType", "Dewdrop-2.0")
	else																	-- no fubar, make our own minimap icon 
		_inst.minimap = self:GenerateMinimapButton( frame, inst );
		_inst.minimap:Reposition();
	end

	if CT_RegisterMod then													-- ct mod and related
		CT_RegisterMod(inst._meta.title, "Display window", 5, self._meta.icon,
			self._meta.desc, "switch", _inst.instance, function(self) self:ExecChatCommandAce() end );
	end
	
end

function KarmaAce:OnPlayerEnterWorldAce( frame, inst )

end


function KarmaAce:OnUpdateFuBarTooltip()
	GameTooltip:AddLine(self._L[self.title]);
	GameTooltip:AddLine(self._L["SHOW_TOOLTIP_FU"], 0.2, 1, 0.2, 1);
end


function KarmaAce:OnFuBarClick(button)
	self:ExecChatCommandAce( IsShiftKeyDown() and "options" )
end


function KarmaAce:ExecChatCommandAce( command )
	local cmd = (command and " "..command) or "";
	self._karma:ExecuteChatCommand( "/"..self._karma._instance.name..cmd );
end


function KarmaAce:OnInitialize( )
	local _inst = self._karma._acelib;
	if _inst.menu and _inst.lib.fu then
		self._karma:ArgsToTable(_inst.menu.args, _inst.lib.fu:GetEmbedRockConfigOptions(_inst.instance));
		for i, v in pairs (_inst.menu.args) do
			if v.type == "boolean" then v.type = "toggle" end
			if v.type == "choice" then v.type = "text" end
			if v.choices then v.validate = v.choices end
			if i == "hide" then v.name = "Hide" end
		end
	end
end


function KarmaAce:GenerateMinimapButton( frame, inst )
	local _inst = inst._acelib;
	
	self._minimap = self._minimap or {
		OnMouseDown	= function(self) self.icon:SetTexCoord(0, 1, 0, 1) end,
		OnMouseUp	= function(self) self.icon:SetTexCoord(0.075, 0.925, 0.075, 0.925) end,
		OnDragStart	= function(self) self._ismoving = true end,
		OnDragStop	= function(self) self.icon:SetTexCoord(0.075, 0.925, 0.075, 0.925); self._ismoving = false end,
		OnUpdate	= function(self) if self._ismoving then
				local cx, cy = GetCursorPosition()
				local x, y = Minimap:GetCenter()
				local es = Minimap:GetEffectiveScale()
				self:Reposition( math.deg(math.atan2(y*es-cy, x*es-cx))+180 )
			 end end,
		OnClick		= function(self, button) local h=self._handler return h.OnFuBarClick and h:OnFuBarClick(button) end,
		OnEnter		= function(self, button) local g,h=GameTooltip,self._handler; 
			g:SetOwner(self,"ANCHOR_RIGHT"); g:ClearLines(); if h.OnUpdateFuBarTooltip then h:OnUpdateFuBarTooltip() end g:Show() end,
		OnLeave		= function(self, button) GameTooltip:Hide() end,
		Reposition	= function(self, a)
				local o = self._options
				if not o.show then self:Hide(); return end
				a = a or o.position; o.position = a;
				self:Show();
				self:ClearAllPoints();
				self:SetPoint("CENTER", Minimap, "CENTER", (Minimap:GetWidth()/2+10)*cos(a), (Minimap:GetHeight()/2+10)*sin(a))
			end,
	};

	local m = CreateFrame("Button", "", Minimap);
	m._ismoving = false;
	m._handler = _inst.instance;
	m._options = _inst.db.profile.minimap;
	m:SetToplevel(true); m:SetMovable(true); m:SetFrameStrata("LOW");
	m:SetWidth(20);	m:SetHeight(20);
	m:SetPoint("RIGHT", Minimap, "LEFT", 0,0);
	m.icon = m:CreateTexture("", "BACKGROUND")
	m.icon:SetTexture(inst._meta.icon)
	m.icon:SetTexCoord(0.075, 0.925, 0.075, 0.925)
	m.icon:SetWidth(20); m.icon:SetHeight(20);
	m.icon:SetPoint("TOPLEFT", m, "TOPLEFT", 0, 0)
	m.mask = m:CreateTexture("", "OVERLAY")
	m.mask:SetTexture("Interface\\Minimap\\Minimap-TrackingBorder")
	m.mask:SetTexCoord(0.0, 0.6, 0.0, 0.6)
	m.mask:SetWidth(36); m.mask:SetHeight(36);
	m.mask:SetPoint("TOPLEFT", m, "TOPLEFT", -8, 8)
	m:RegisterForClicks("LeftButtonUp","RightButtonUp")
	m:RegisterForDrag("LeftButton")
	m:SetScript("OnMouseUp", self._minimap.OnMouseUp )
	m:SetScript("OnDragStart", self._minimap.OnDragStart )
	m:SetScript("OnDragStop", self._minimap.OnDragStop )
	m:SetScript("OnUpdate", self._minimap.OnUpdate );
	m:SetScript("OnClick", self._minimap.OnClick )
	m:SetScript("OnEnter", self._minimap.OnEnter )
	m:SetScript("OnLeave", self._minimap.OnLeave )
	m.Reposition = self._minimap.Reposition;

	return m;
end
